var global;
var windowWidth,windowHeight;
var img_h,img_w;
var work_area;
var tW,tH,tK;
var mapW,mapH;
var prev_layer = 1;
var cur_layer;
var dataPath = 'data/pp_data.json';
var coordsData;
var hashes = ['#c','#p','#m','#i','#s'];
var twitter;
var tw_button;
var twit_inner;
var stateTW = false;
var data_manager = {};
var prevHash,popupHash;

window.onload = function() {
    var txts = document.getElementsByTagName('TEXTAREA')

    for(var i = 0, l = txts.length; i < l; i++) {
        if(/^[0-9]+$/.test(txts[i].getAttribute("maxlength"))) {
            var func = function() {
                var len = parseInt(this.getAttribute("maxlength"), 10);

                if(this.value.length > len) {
                    alert('Maximum length exceeded: ' + len);
                    this.value = this.value.substr(0, len);
                    return false;
                }
            }

            txts[i].onkeyup = func;
            txts[i].onblur = func;
        }
    }
}



function setData(){
   // console.log('onDataLoaded: ',data);
    coordsData = {
            "layer_1Map":[
                [139,85,142,143,354,143,354,88],
                [411,95,741,98,742,187,413,189],
                [699,383,1147,475],
                [135,379,530,381,536,503,136,505],
                [298,264,487,263,488,345,300,347],
                [682,245,903,255,941,282,939,296,684,302],
                [766,305,1150,305,1152,345,767,343]
            ],
            "layer_2Map":[
                [270,185,694,180,692,68,265,68],
                [423,275,456,267,604,311,885,311,890,375,550,384,421,316],
                [734,19,1122,36,1115,152,728,155],
                [772,429,1126,493]
            ],
            "layer_3Map":[
                [167,52,273,70,295,106,515,110,497,150,294,160,208,203,139,150],
                [719,29,836,52,1093,75,1044,142,756,167,701,118],
                [463,223,517,222,517,285,715,293,712,347,444,347],
                [747,246,1026,246,1032,373,747,379]
            ],
            "layer_4Map":[
                [750,85,1114,308],
                [221,242,509,349],
                [356,78,696,179]
            ],
            "layer_5Map":[
                [155,82,272,79,281,101,585,106,586,169,277,169,197,201,152,149],
                [311,187,674,213,681,302,303,303],
                [690,294,1033,302,1032,375,690,383],
                [155,264,266,263,268,347,457,354,462,421,158,418],
                [739,105,1131,247]
            ]
        }

    init();
}

function init(){
    if(!window.location.hash || window.location.hash == '' || window.location.hash == '#'){
        //window.location.hash = hashes[0];
        //showAboutPopup();
    } else {
        //setPage($.inArray(window.location.hash,hashes)+1);
        var tArr = window.location.hash.split('-');
        prevHash = tArr[0];
        if(!tArr[0] || tArr[0]=='' || tArr[0]=='#')
            setPage(1);
        else
            setPage($.inArray(tArr[0],hashes)+1);
        if(tArr[1]&&tArr[1]!=popupHash){
            showPopup(tArr[1]);
            fillPopupBottom();
        }
    }

    //console.log('hash2: '+window.location.hash);


    global.window.resize(onResize);
    onResize();

    global.window.bind('hashchange', onHashChange);

    global.map_img.animate({opacity:1},200);
    global.map_bg.animate({opacity:1},100);
    global.content.animate({opacity:1},300);
    global.icons_content.animate({opacity:1},300);

    $('#cloud_1').animate({opacity:1},500);
    $('#cloud_2').animate({opacity:1},500);
    $('#cloud_3').animate({opacity:1},500);
    $('#cloud_4').animate({opacity:1},500);

    $('.selectBlock').sSelect();

    twInit();
}

var sending;

function addform_send(){
    if(sending) return;
    sending = true;
    var sId = $("#add_form input[name=id]").val();
    var sWish = $("#add_form textarea[name=wish]").val();
    var sSend = $("#add_form input[name=send]").val();
    console.log('addform_send: ',sId,sWish,sSend);
    sendAddData();
}

function sendAddData(){//aUrl,aSucces,aFail
    var tForm = $("#add_form");
    $('#add_form_status').text('');
    $.ajax({
        type: tForm.attr('method'),
        url: tForm.attr('action'),
        data: tForm.serialize(),
        beforeSend: function(request) {

        },
        success: function(data, textStatus, request) {
            sending = false;
            $('#add_form_status').css('color','#000000');
            $('#add_form_status').text('Thanks. Goal was added.');
            $("#add_form textarea[name=wish]").val('');
        },
        error: function(request, status, error) {
            sending = false;
            $('#add_form_status').css('color','#f0503a');
            $('#add_form_status').text('Error. Try again');
        }
    });
}


var trailimage=["img/cursor_icon.png", 24, 24] //image path, plus width and height
var offsetfrommouse=[16,16]; //image x,y offsets from cursor position in pixels. Enter 0,0 for no offset


function followmouse(e){
    var xcoord=offsetfrommouse[0]
    var ycoord=offsetfrommouse[1]

    if (typeof e != "undefined"){
        xcoord+=e.pageX
        ycoord+=e.pageY
    } else if (typeof window.event !="undefined"){
        xcoord+=event.clientX
        ycoord+=event.clientY
    }

    $("#trailimageid").css('left',xcoord+"px");
    $("#trailimageid").css('top',ycoord+"px");
    //console.log('followmouse: ',$("#trailimageid").css('left'),$("#trailimageid").css('top'),$("#trailimageid").css('visibility'));
}

function showtrail(){
    $("#trailimageid").css('display','block');
    //console.log('showtrail: ',$("#trailimageid"));
    document.onmousemove=followmouse
}

function hidetrail(){
    $("#trailimageid").css('display','none');
   // console.log('hidetrail: ',$("#trailimageid"));
    document.onmousemove=""
}

function aboutclick(obj){
    if(popupHash == 'a')return;
    popupHash = 'a';
    prevHash = window.location.hash;
    window.location.hash = prevHash+'-'+popupHash;
}

function addclick(obj){
    if(popupHash == 'add')return;
    popupHash = 'add';
    prevHash = window.location.hash;
    window.location.hash = prevHash+'-'+popupHash;
}

function showvideoclick(obj){
    if(popupHash == 'v')return;
    popupHash = 'v';
    prevHash = window.location.hash;
    window.location.hash = prevHash+'-'+popupHash;

    var tBlock = $('#video_cont');
    var tHtml = '<iframe src="http://player.rutv.ru/index/iframe/video_cid/43366/acc_video_id/446448" frameborder="0" style="width: 582px; height: 435px; border: none;"></iframe>';
    tBlock.html(tHtml);
}

function areaclick(obj){

    //console.log('areaclick: ',$("#lean_overlay"));

    $("#lean_overlay").click(onPopupClose);


    var target = $(obj).attr('href');
    if(target.substr(1)==popupHash)return;
    popupHash = target.substr(1);
    //console.log("areaclick",target,popupHash);

    prevHash = window.location.hash;
    window.location.hash = prevHash+'-'+popupHash;



    //setTimeout(posPopup,200);

    fillPopupBottom();
}

function posPopup(){
   // console.log('areaclick1: ',$('#'+popupHash).height(),$('#'+popupHash).y,$('#'+popupHash).css('top'));

    $('#'+popupHash).css('top',(Math.floor((windowHeight-$('#'+popupHash).height())/2)-37)+'px');

   // $('#'+popupHash).animate({'top':(Math.floor((windowHeight-$('#'+popupHash).height())/2)-75)},300,'swing');

    //console.log('areaclick2: ',$('#'+popupHash).height(),$('#'+popupHash).y,$('#'+popupHash).css('top'));
}

function onPopupClose(){
    //console.log('close click: ');
    if(popupHash == 'v'){
        var tBlock = $('#video_cont');
        var tHtml = '';
        tBlock.html(tHtml);
    }
    $('.pp').css('display', 'none');
    $('#lean_overlay').fadeOut(200);
    popupHash = '';
    window.location.hash = prevHash;
}

function showAboutPopup(){
   $("#about_link").click();
   $("#lean_overlay").click(onPopupClose);
}

function fillPopupBottom(){

    var tBot = $('#'+popupHash).find('.bottom_content');
    //console.log('fillPopupBottom: ',$('#'+popupHash),tBot,tBot.html(),Boolean(tBot.html()));
    var tHash = window.location.hash;

    if(!tBot.html() || tBot.html()==''){
        console.log('fillPopupBottom1: ',tHash,stripHash(tHash));
         var tHtml = '<div class="right_likes"><div class="like" style="width:85px; margin-top:1px;"><div class="facebook_like"><iframe src="//www.facebook.com/plugins/like.php?href=http%3A%2F%2F2018.minsvyaz.ru%2Fen%2F'+encodeURIComponent('fblikea54e.html?page='+stripHash(tHash))+'&amp;send=false&amp;layout=button_count&amp;width=450&amp;show_faces=true&amp;action=like&amp;colorscheme=light&amp;font&amp;height=21&amp;appId=439346569442365&amp;locale=en_US" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:450px; height:21px;" allowTransparency="true"></iframe></div></div><div class="like" style="width:90px; margin-right:3px;"><div id="vk_like" style="width: 100px; background: none repeat scroll 0% 0% transparent; height: 22px; position: relative; clear: both;"><iframe width="100%" allowTransparency="true" scrolling="no" height="22px" frameborder="0" name="fXD846e1" src="http://vk.com/widget_like.php?app=3095251&amp;width=100%&amp;page='+getCharCode('en'+popupHash)+'&amp;url=http%3A%2F%2F2018.minsvyaz.ru%2Fen%2F'+encodeURIComponent(tHash)+'&amp;type=mini&amp;verb=0&amp;title=&amp;description=&amp;image=&amp;text=&amp;h=22&amp;1397a5985be" id="vkwidget2" style="overflow: hidden; height: 22px; width: 100px; z-index: 150;"></iframe></div></div><div class="like" style="width:85px; margin-top:1px;"><iframe allowtransparency="true" frameborder="0" scrolling="no" src="https://platform.twitter.com/widgets/tweet_button.html?button_hashtag=%D0%BC%D0%BA%D1%812018&url=http%3A%2F%2F2018.minsvyaz.ru%2Fen%2F'+encodeURIComponent(tHash)+'&counturl=http%3A%2F%2F2018.minsvyaz.ru%2Fen%2F'+encodeURIComponent(tHash)+'&lang=en" style="width:130px; height:20px;"></iframe></div></div><div class="left_likes"><div class="like" style="width:auto; margin-right:4px; display:inline-block;"><iframe src="like.php?hash='+encodeURIComponent(tHash)+'" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:171px; height:24px;" allowTransparency="true"></iframe></div></div><div class="clearing"></div>';
//
        tBot.html(tHtml);
    } else {
        //console.log('fillPopupBottom2: ');
    }

}

function stripHash(str){
    return str.replace("#","");
}

function getCharCode(aHash) {
    var tNum = '';
    var tLen = aHash.length
    for (var i = 0; i < tLen; i++) {
        tNum += aHash.charCodeAt(i);
    }
    return tNum;
}
function onHashChange() {
    //console.log('onHashChange: ['+window.location.hash+']',prevHash,popupHash);
    if(!window.location.hash || window.location.hash == '' || window.location.hash == '#'){
       // console.log('onHashChange1');
        setPage(1);
        if(popupHash){
            onPopupClose();
        }
    } else {
        var tArr = window.location.hash.split('-');
       // console.log('onHashChange2: ',tArr,popupHash,tArr[1]);
        if(!tArr[0] || tArr[0]=='' || tArr[0]=='#')
            setPage(1);
        else
            setPage($.inArray(tArr[0],hashes)+1);
        if(tArr[1]&&tArr[1]!=popupHash){
            showPopup(tArr[1]);
        } else if(!tArr[1] && popupHash){
            onPopupClose();
        }
    }
}

function showPopup(aName){
    console.log('showPopup: ',aName);
    popupHash = aName;
    if(aName == 'a')
        $("#about_link").click();
    else if(aName == 'add')
        $("#add_but").click();
    else if(aName == 'v'){
        var tBlock = $('#video_cont');
        var tHtml = '<iframe src="http://player.rutv.ru/index/iframe/video_cid/43366/acc_video_id/446448" frameborder="0" style="width: 582px; height: 435px; border: none;"></iframe>';
        tBlock.html(tHtml);
        $("#show_video_but").click();
    }else
        $('area[href="#'+aName+'"]').click();

}

function onResize(){
    windowWidth = global.window.width();
    windowHeight = global.window.height();
    global.content.height(windowHeight-60);
    global.clouds_cont.height(windowHeight-60);
		global.twitter.height(windowHeight-65);
		global.twit_inner.height(windowHeight-65-30);

    if(windowHeight>800){
        var tTop = Math.floor((windowHeight-800)/270*50);
        $('.button_add').css('top',110+tTop);
        global.header.css('paddingTop',tTop);
    }else{
        $('.button_add').css('top',110);
        global.header.css('paddingTop',0);
    }

    $(".button_videopopup").css('left',Math.floor((windowWidth-400)*0.5+40));

    if(windowHeight-work_area < img_h){
        tH = windowHeight-work_area
        tK = tH/img_h;
        tW = tK*img_w;
    } else {
        tH = img_h;
        tK = 1;
        tW = img_w;
    }

	for(var i = 1; i<=5; i++){
		$('#layer_'+i).height(tH);
		$('#layer_'+i).width(tW);
        $('#layer_'+i).css('left',Math.floor((windowWidth-$('#layer_'+i).width())*0.5));
        $('#layer_'+i).css('top',Math.floor((windowHeight-$('#layer_'+i).height())*0.5));
	}


    global.map_img.width(Math.ceil(mapW*tK));
    global.map_img.height(Math.ceil(mapH*tK));
    global.map_img.css('left',Math.floor((windowWidth-global.map_img.width())*0.5));
    global.map_img.css('top',Math.floor((windowHeight-global.map_img.height())*0.5));
	global.tw_button.css('top',Math.floor((windowHeight-65)/2 - 53));

    for (var obj in coordsData) {
        resizeMapCoords(obj)
    }

    if(twData && twData.length>0){
        clearTweets();
        twBuild(curI);
    }

    if(popupHash && popupHash != ''){
        posPopup();
    }

    $('#add_pp').css('top',(Math.floor((windowHeight-$('#add_pp').height())/2)-37)+'px');
}

function resizeMapCoords(obj){
    var cdata = coordsData[obj];
    var coords;
    var len;
    var new_coords;
    var k=0;
    var tc;

    $('map[name='+obj+']').find('area').each(function() {
        new_coords = [];
        coords = cdata[k];
        len = coords.length;
        for(var i=0; i<len; i++) {
            tc = Math.floor(coords[i]*tK);
            new_coords[i]=tc;
        }
        $(this).attr("coords", new_coords.join(','));
        k++;
    });
}


function showLayer(pageI){
    if(cur_layer==pageI)return;
	setPage(pageI);
    window.location.hash = hashes[pageI-1];
}

function setPage(pageI){
    if(cur_layer == pageI) return;

    $('#mn'+cur_layer).attr('class', 'normal');

    $('#mn'+cur_layer).css('background','url(img/menu_point.png) no-repeat top center');
    $('#mn'+cur_layer).children('.left').css('background','none');
    $('#mn'+cur_layer).children('.left').children('.right').css('background','none');
    $('#mn'+cur_layer).children('.left').children('.right').css('color','#FFF');

    if($('#mn'+pageI).attr('class') != 'active'){
        $('#layer_'+prev_layer).animate({opacity:0},300, 'linear', onLayerHided);
        $('#mn'+pageI).attr('class', 'active');
        $('#mn'+pageI).css('background','none');
        $('#mn'+pageI).children('.left').css('background','#dadfe8 url(img/menu_on_left.png) no-repeat top left');
        $('#mn'+pageI).children('.left').children('.right').css('background','url(img/menu_on_right.png) no-repeat top right');
        $('#mn'+pageI).children('.left').children('.right').css('color','#000000');
        cur_layer = pageI;
    }
}
function onLayerHided(){
	$('#layer_'+prev_layer).css('display', 'none');
	$('#layer_'+cur_layer).css('display', 'block');
	$('#layer_'+cur_layer).animate({opacity:1},300);
    prev_layer = cur_layer;
}

function setDocumentClickListener(){
    $(document).click(function(e){
        var target = $(e.target);
        console.log('sDCL: ',target);
        if (target.is('#twit_content') || target.parents('#twit_content').length) return;
        $(document).unbind('click', arguments.callee);
        if (target.is('#tw_button') || target.parents('#tw_button').length) return;
        onTwButClick(e);
    });
}

function onTwButClick(e){
    $("#tw_button img").css('width', '10px');
    $("#tw_button img").css('height', '10px');
    if(stateTW == true){
        $("#tw_button img").attr('src', 'img/next.png');

        $('#twitter').animate({left:-337}, 400,'swing');
        stateTW = false;
    } else {
        $("#tw_button img").attr('src', 'img/prev.png');
        $('#twitter').animate({left:0}, 400,'swing');
        stateTW = true;

        e.stopPropagation();
        setDocumentClickListener();

    }
}

$(document).ready(function(){
    global = {
        window: $(window),
        body: $('body'),
        header: $('#header'),
        content: $('#content'),
        clouds_cont: $('#clouds_cont'),
        icons_content: $('#icons_content'),
        map_img: $('#map_bg_img'),
        map_bg: $('#map_bg'),
        twitter: $('#twitter'),
        tw_button: $('#tw_button'),
        twit_inner: $('#twit_inner')
    };

    img_h = $('#layer_1').height();
    img_w = $('#layer_1').width();
    work_area = 94 + 77 + 30;
    mapW = 1920;
    mapH = 1920;

    cur_layer = 1;
    prevHash = '';

   // console.log('hash1: '+window.location+' , '+window.location.hash);

    $('a[rel*=leanModal]').leanModal({ top : 20 });
    $('area[rel*=leanModal]').leanModal({ top : 20 });
    $('.close_icon').click(onPopupClose);

    $("#tw_button").click(onTwButClick);

    setData();

});