var global;
var tw_datapath;
var retrycount=0;
var retrymax=5;
var retrytimeout=3000;
var twData;
var isFirstTime = true;
var nextI=0;
var monthObj = {Jan:'января',Feb:'февраля',Mar:'марта',Apr:'апреля',May:'мая',Jun:'июня',Jul:'июля',Aug:'августа',Sep:'сентября',Oct:'октября',Nov:'ноября',Dec:'декабря'}
var windowWidth,windowHeight;
var curI,lastI,prevI;
var twTotalNum = 0;

function twInit(){
   /* global = {
        window: $(window)
    }*/

    var hash = '#МКС2018';
    var start_page = 1;
    var show_num = 55;
    curI = 0;
    twData = [];
    tw_datapath = 'http://search.twitter.com/search.json?q='+encodeURIComponent(hash)+'&page='+start_page+'&rpp='+show_num+'&lang=ru&result_type=recent&callback=?';
    tw_callback = processData;

    //console.log('twInit: ',tw_datapath);

   // global.window.resize(onResize);
   // onResize();

    getData(tw_datapath,tw_callback);

}
/*

function onResize(){
    windowWidth = global.window.width();
    windowHeight = global.window.height();

    clearTweets();
    twBuild(curI);
}
*/

function getData(aUrl,aSucces,aFail){
    var tUrl = aUrl+'&_='+Math.floor(Math.random()*10000000);
    $.ajax({
        url: aUrl,
        dataType: 'json',
        async: true,
        beforeSend: function(request) {
            //console.log('starting AJAX request to get Twitter data');
        },
        success: function(data, textStatus, request) {
            //console.log('AJAX request to get Twitter succeeded: status=' + textStatus);
            //console.log('success: ',data);
            if(aSucces)
                aSucces(data);
        },
        error: function(request, status, error) {
            //console.log('AJAX request to get user data --> Error: ' + status);
            if(aFail){
                aFail();
            } else {
                retrycount++;
                if(retrycount<retrymax)
                    setTimeout(retry,retrytimeout)
            }
        }
    });
}

function processData(aData){
    var tData = aData.results;
    var dc;
    var obj;
    len = tData.length;
    for (var i = 0; i < len; i++) {
        dc = tData[i];
        if(checkHasItem(dc.id)) continue;
        obj = {};
        obj.id = dc.id;
        obj.user = dc.from_user;
        obj.name = dc.from_user_name;
        obj.date = dc.created_at;
        obj.avatar = dc.profile_image_url;
        obj.text = dc.text;
        twData.push(obj);
    }
    twTotalNum = twData.length;
    if(isFirstTime){
        twBuild(curI);
        isFirstTime = false;
    }
}

function twBuild(aStart){
    //console.log('twBuild: ',twData);
    //alert('builded');
    var tH = $(window).height()-155;
    var item;
    var obj;
    prevI = curI;
    curI = aStart;
    for (var i = aStart; i < twTotalNum; i++) {
        obj = twData[i];
        createItem(obj);
        lastI = i;
        nextI = i;
        if($('#tw_list').height()>tH){
            removeLastItem();
            nextI = i-1;
            break;
        }
    }
    setArrows();
}

function removeLastItem(){
    $('#tw_list li:last-child').remove();
}

function clearTweets(){
    $('#tw_list').empty();
}

function createItem(dc){
    var tCode = '<li><div class="avatar"><a href="https://twitter.com/'+dc.user+'" target="_blank"><img src="'+dc.avatar+'" alt="" width="33" height="33"></a></div><div class="tw_txt"><p class="name"><a href="https://twitter.com/'+dc.user+'" class="name_link" target="_blank">'+dc.name+'</a> <span><a href="https://twitter.com/'+dc.user+'" class="user_link" target="_blank">@'+dc.user+'</a></span></p><p class="date">'+parseDate(dc.date)+'</p><div class="clearing"></div><p class="com">'+parseText(dc.text)+'</p></div><div class="clearing"></div></li>';
        $('#tw_list').append(tCode);
}

function parseText(aText){
    //var tCode = '<a href="https://twitter.com/adagamov" title="" target="_blank">@adagamov</a> А отчасти-то, как доморощ.отеч.истцы пытаются засудить Мадонну.Но есть и разница.Мерседесу/М-софту пофиг,а Чикконе могут ипривлечь';
    var regexp = /@(\w+)/gim;
    var tCode = aText.replace(regexp, '<a href="https://twitter.com/$1" title="" target="_blank">@$1</a>');
    regexp = /#([a-zA-Zа-яА-Я0-9_]+)/gim;
    tCode = tCode.replace(regexp, '<a href="https://twitter.com/search/?src=hash&q=%23$1" title="" target="_blank">#$1</a>');
    return tCode;
}

function parseDate(aDate){
    //"Tue, 28 Aug 2012 18:18:21 +0000"
    var tArr = aDate.split(" ");
    tDate = tArr[1]+' '+monthObj[tArr[2]];
    return tDate
}

function checkHasItem(aId){
    for (var i = 0; i < twTotalNum; i++) {
        if(twData[i].id == aId)
            return true;
    }
    return false;
}

function retry(){
    getData(tw_datapath,tw_callback);
}

function setArrows(){
    if(curI==0){
        $('#tw_but_left').attr('class', 'disabled');
    } else {
        $('#tw_but_left').attr('class', '');
    }
    //console.log('setArrows: ',lastI,twTotalNum);
    if(lastI >= twTotalNum-1){
        $('#tw_but_right').attr('class', 'disabled');
    } else {
        $('#tw_but_right').attr('class', '');
    }
}

function showNext(){
   // console.log('showNext: ',$('#tw_but_right').attr('class'),nextI);
    if($('#tw_but_right').attr('class') == 'disabled') return;
    clearTweets();
    twBuild(nextI);
}

function showPrev(){
    if($('#tw_but_left').attr('class') == 'disabled') return;
    clearTweets();
    twBuild(prevI);
}
